accounts/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views
from accounts.views import signup


urlpatterns = [
    path("login/", auth_views.LoginView.as_view(), name="login"),
    path("logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

alphastretch/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('accounts.urls')),
    #path('blog/', include('blog.urls')),
    path('storefront/', include('storefront.urls')),
]

blog/urls.py
from django.urls import path

storefront/urls.py
from django.urls import path
from storefront.views import(
    StorefrontCreateView,
    StorefrontListView,
    StorefrontDetailView,
)



urlpatterns = [
    path("", StorefrontListView.as_view(), name="store_listview"),
    path("create/", StorefrontCreateView.as_view(), name="store_createview"),
    path("detail/", StorefrontDetailView.as_view(), name="store_detailview")
]

accounts/models.py
from django.db import models

# Create your models here.

blog/models.py
from django.db import models

# Create your models here.

gaming/models.py
from django.db import models

# Create your models here.

shows/models.py
from django.db import models

# Create your models here.

storefront/models.py
from django.db import models
from django.conf import settings

# Create your models here.


USER_MODEL = settings.AUTH_USER_MODEL

class Storefront(models.Model):
    name = models.CharField(max_length=125)
    description = models.TextField()
    created = models.DateTimeField(auto_now_add=True)
    image = models.URLField(null=True, blank=True)
    members = models.ManyToManyField(USER_MODEL, related_name="storefront")

    def __str__(self):
        return self.name

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from django.contrib.auth import login

# Create your views here.




def signup(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            username = request.POST["username"]
            password = request.POST["password1"]
            user = User.objects.create_user(username, password)
            user.save()
            login(request, user)
            return redirect("home")
    else:
        form = UserCreationForm(request.POST)
    context = {"form": form}
    return render(request, "registration/signup.html", context)

blog/views.py
from django.shortcuts import render

# Create your views here.

gaming/views.py
from django.shortcuts import render

# Create your views here.

shows/views.py
from django.shortcuts import render

# Create your views here.

storefront/views.py
from email.policy import default
from django.shortcuts import render, redirect
from storefront.models import Storefront
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic.list import ListView
from django.views.generic.edit import CreateView
from django.views.generic.detail import DetailView

# Create your views here.


class StorefrontListView(LoginRequiredMixin, ListView):
    models = Storefront
    template_name = "storefront/list.html"
    paginate_by = 10

    def get_queryset(self):
        return Storefront.objects.filter(members=self.request.user)

class StorefrontDetailView(LoginRequiredMixin, DetailView):
    models = Storefront
    template_name = "storefront/detail.html"
    
    def get_queryset(self):
        return Storefront.objects.filter(members=self.request.user)


class StorefrontCreateView(LoginRequiredMixin, CreateView):
    models = Storefront
    template_name = "storefront/create.html"
    fields = ["name", "description" ]

    def form_valid(self, form):
        owner = form.save(commit=False)
        owner.user = self.request.user
        owner.save()
        return redirect("store_detailview", pk=owner.id)

storefront/templates/base.html
<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Store</title>
  <link rel="stylesheet" href="{% static 'css/app.css' %}">
</head>
<body>
    <header>
      <nav>
        <ul>
          <li>
            <a href="{% url 'store_listview' %}">Home</a>
          </li>
        </ul>
      </nav>
      {% block pagination %}
      {% endblock pagination %}
    </header>
    {% block content %}
    {% endblock content %}
  </body>
  
  </html>
  
  

storefront/templates/paginate.html
{% extends 'base.html' %}

{% block pagination %}
  <div class="pagination">
    <span class="step-links">
      {% if page_obj.has_previous %}
        <a href="?page=1">&laquo; first</a>
        <a href="?page={{ page_obj.previous_page_number }}">previous</a>
      {% endif %}

      <span class="current">
        Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.
      </span>

      {% if page_obj.has_next %}
        <a href="?page={{ page_obj.next_page_number }}">next</a>
        <a href="?page={{ page_obj.paginator.num_pages }}">last &raquo;</a>
      {% endif %}
    </span>
  </div>
{% endblock pagination %}

storefront/templates/storefront/create.html
{% extends 'base.html' %}

{% block content %}

<main>
    <div>
        <h1>Add a New Show</h1>
        <form method="post">
            {% csrf_token %} {{ form.as_p }}
            <button class="button">Create</button>
        </form>
    </div>
</main>


{% endblock content %}

storefront/templates/storefront/detail.html
{% extends 'base.html' %}
{% load markdownify %}
{% block content %}


<main>
    <div>
        <h1>{{ storefront.name }}</h1>
        {{ storefront.description|markdownify }}
        <h2>Tasks</h2>
        <p><a href="{% url 'create_task' %}">Create a new task</a></p>
        {% if storefront.shows.all %}
            <table>
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>Assignee</th>
                        <th>Start date</th>
                        <th>Due date</th>
                        <th>Is completed</th>
                    </tr>
                </thead>
                <tbody>
                    {% for info in storefront.shows.all %}
                        <tr>
                            <td>{{ info.name }}</td>
                            <td>{{ info.assignee }}</td>
                            <td>{{ info.start_date }}</td>
                            <td>{{ info.due_date }}</td>
                            {% if info.is_completed %}
                                <td>Yes</td>
                            {% else %}
                                <td>No</td>
                            {% endif %}
                        </tr>
                    {% endfor %}
                </tbody>
            </table>
        {% else %}
            <p>This list is empty.</p>
        {% endif %}
    </div>
</main>


{% endblock content %}

storefront/templates/storefront/list.html
{% extends 'base.html' %}

{% block content %}

<main>
    <div>
        <h1>My Lists</h1>
        {% if not storefront_list %}
            <p>Nothing in your list.</p>
        {% else %}
            <table>
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>Number of shows</th>
                    </tr>
                </thead>
                <tbody>
                    {% for things in storefront_list %}
                        <tr>
                            <td>
                                <a href="{% url 'store_detailview' things.pk %}">
                                    {{ things.name }}
                                </a>
                            </td>
                            <td>{{ things.shows.all|length }}</td>
                    {% endfor %}
                </tr>
        {% endif %}
    </tbody>
</table>
</div>
</main>
{% endblock content %}